// Test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <winsvc.h>

void ReportError() ;

void main(int argc, char* argv[])
{
	if(argc != 3)
	{
		printf("Usage:\nTest /i <service name>\n");
		printf("Test /u <service name>\n");
		return ;
	}

	SC_HANDLE hSCM ;
	hSCM = ::OpenSCManager ( NULL, NULL,SC_MANAGER_ALL_ACCESS ) ;
	if ( hSCM == NULL)
	{
		printf( "cannot establish connection with SCM" ) ;
		return ;
	}
	
	char path[MAX_PATH] ; 
	::ExpandEnvironmentStrings("%SystemRoot%\\system32\\drivers\\",path,MAX_PATH);
		
	char tmp[MAX_PATH];
	sprintf(tmp,"%s.sys",argv[2]);
	strcat(path,tmp);
	
	SC_HANDLE hs ;

	if(stricmp(argv[1],"/i") == 0) // install
	{
		// Creates a driver service.
		hs = CreateService( hSCM,					// SCManager database
							argv[2],				// name of service
							argv[2],				// name to display
							SERVICE_ALL_ACCESS,     // desired access
							SERVICE_KERNEL_DRIVER,  // service type
							SERVICE_DEMAND_START,   // start type
							SERVICE_ERROR_NORMAL,   // error control type
							path,					// service's binary path
							NULL,                   // no load ordering group
							NULL,                   // no tag identifier
							NULL,                   // no dependencies
							NULL,                   // LocalSystem account
							NULL );                 // no password
									
		if ( hs )
		{
			if(!StartService( hs, 0, NULL)) 
				ReportError();
			

			printf("\nsucceeded in starting the service");

			CloseServiceHandle( hs);
		}
		else
			ReportError();
	}
	else if (stricmp(argv[1],"/u")==0) 	// unload
	{
		SERVICE_STATUS  status;
		hs = OpenService( hSCM, argv[2], SERVICE_ALL_ACCESS );
		if (hs)
		{
			ControlService( hs, SERVICE_CONTROL_STOP, &status );
			DeleteService( hs );
			CloseServiceHandle( hs );
		}
		else
			ReportError();
	}
	else
	{
		printf("Usage:\nTest /i <service name>\n");
		printf("Test /u <service name>\n");
	}
	
	::CloseServiceHandle( hSCM );
}

void ReportError()
{
	LPVOID lpMsgBuf;
	::FormatMessage(  FORMAT_MESSAGE_ALLOCATE_BUFFER | 
					FORMAT_MESSAGE_FROM_SYSTEM | 
					FORMAT_MESSAGE_IGNORE_INSERTS,
					NULL,
					GetLastError(),
					MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
					(LPTSTR) &lpMsgBuf,
					0,
					NULL );
	
	printf((char*)lpMsgBuf);
	::LocalFree( lpMsgBuf );
}