extern "C" 
{
	#include <wdm.h>
}

struct DEVICE_EXTENSION 
{
	UNICODE_STRING SymLinkName;	// external name
} ;

void DriverUnload (	IN PDRIVER_OBJECT pDrvObj) ;
NTSTATUS DispatchCreate (IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp ) ;
NTSTATUS DispatchClose (IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp ) ;

extern "C" NTSTATUS DriverEntry(IN PDRIVER_OBJECT pDriverObject,IN PUNICODE_STRING RegistryPath)
{
    // Announce other driver entry points
	pDriverObject->DriverUnload = DriverUnload;
	pDriverObject->MajorFunction[IRP_MJ_CREATE] = DispatchCreate;
	pDriverObject->MajorFunction[IRP_MJ_CLOSE] = DispatchClose;
	
	UNICODE_STRING devname ;
	RtlInitUnicodeString(&devname,L"\\Device\\MyDevice0");
	
	PDEVICE_OBJECT pDevObj;
	// Now create the device
	NTSTATUS status = IoCreateDevice( pDriverObject,
						sizeof(DEVICE_EXTENSION),
						&devname,
						FILE_DEVICE_UNKNOWN,
						0, TRUE,
						&pDevObj );
	if (!NT_SUCCESS(status))
		return status;
	// Initialize the Device Extension
	DEVICE_EXTENSION* pDevExt;
        pDevExt = (DEVICE_EXTENSION*)pDevObj->DeviceExtension;
	
	// Form the symbolic link name
	UNICODE_STRING linkname ;
	RtlInitUnicodeString(&linkname,L"\\??\\MYDEV");
	pDevExt->SymLinkName = linkname;// symLinkName;

	// Now create the link name
	status = IoCreateSymbolicLink( &linkname, &devname );
	if (!NT_SUCCESS(status)) 
	{
		// if it fails now, must delete Device object
		IoDeleteDevice( pDevObj );
		return status;
	}
	DbgPrint("drv_app1: in driverentry\n");
	return STATUS_SUCCESS;
}

void DriverUnload (	IN PDRIVER_OBJECT pDrvObj) 
{
	PDEVICE_OBJECT pDevObj = pDrvObj->DeviceObject;

	DEVICE_EXTENSION* pDevExt = (DEVICE_EXTENSION*)pDevObj->DeviceExtension;
	
	IoDeleteSymbolicLink(&pDevExt->SymLinkName);
	IoDeleteDevice( pDrvObj->DeviceObject );
	DbgPrint("drv_app1: in driverunload\n");
}

NTSTATUS DispatchCreate (IN PDEVICE_OBJECT	pDevObj,IN PIRP	pIrp)
{
	pIrp->IoStatus.Status = STATUS_SUCCESS;
	pIrp->IoStatus.Information = 0;	// no bytes xfered
	IoCompleteRequest( pIrp, IO_NO_INCREMENT );
	
	DbgPrint("drv_app1: in dispatchcreate\n");

	return STATUS_SUCCESS;
}

NTSTATUS DispatchClose (IN PDEVICE_OBJECT	pDevObj,IN PIRP	pIrp)
{
	pIrp->IoStatus.Status = STATUS_SUCCESS;
	pIrp->IoStatus.Information = 0;	// no bytes xfered
	IoCompleteRequest ( pIrp, IO_NO_INCREMENT ) ;
	DbgPrint("drv_app1: in dispatchclose\n");
	return STATUS_SUCCESS ;
}
