// Test_ReadWrite.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>

int main(int argc, char* argv[])
{
	
	HANDLE  h = ::CreateFile ("\\\\.\\mydev",
				 			  GENERIC_READ | GENERIC_WRITE,
							  0,		// share mode none
							  NULL,	// no security
							  OPEN_EXISTING,
							  FILE_ATTRIBUTE_NORMAL,
							  NULL );		// no template
	if (h == INVALID_HANDLE_VALUE) 
	{
		printf("Failed to obtain file handle to device: ");
		return 1;
	}

	char buffer[] = "This is a in small case";
	DWORD outCount = sizeof(buffer);

	DWORD bW;
	BOOL status = WriteFile(h, buffer, outCount, &bW, NULL);
	if (!status) 
	{
		printf("WriteFile failed\n");
		return 2;
	}
	if (outCount == bW) 
	{
		printf("Succeeded in writing %d bytes\n", outCount);
		printf("Buffer was: %s\n", buffer);
	}
	else 
	{
		printf("Failed to write the correct number of bytes.\n");
		return 3;
	}
	printf("Attempting to read from device...\n");
	char inBuffer[80];
	DWORD inCount = sizeof(inBuffer);
	DWORD bR;
	status = ReadFile(h, inBuffer, inCount, &bR, NULL);
	if (!status) 
	{
		printf("Failed on call to ReadFile - error: %d\n",GetLastError() );
		return 4;
	}
	if (bR == bW) 
	{
		printf("Succeeded in reading %d bytes\n", bR);
		printf("Buffer was: %s\n", inBuffer);
	}
	else 
	{
		printf("Failed to read the correct number of bytes.\n"
			"Should have read %d bytes, but ReadFile reported %d bytes.\n",
			bW, inCount);
		return 5;
	}
	printf("Attempting to close device LBK1...\n");
	status = CloseHandle(h);
	if (!status) 
	{
		printf("Failed on call to CloseHandle - error: %d\n",GetLastError() );
		return 6;
	}
	return 0;
}






