extern "C" 
{
	#include <NTDDK.h>
}

#include "str.h"

#define max(a,b) (( a > b ) ? a : b )


CString::CString ( ULONG value ) 
{
	uStr.Length = 0 ;
	uStr.MaximumLength = 32 ;
	uStr.Buffer = (PWSTR) ExAllocatePoolWithTag ( PagedPool, uStr.MaximumLength, 1633 ) ;
	RtlIntegerToUnicodeString ( value, 0, &uStr ) ;
}

CString::CString ( const char* p ) 
{
	ANSI_STRING str;
	RtlInitAnsiString ( &str, p ) ;
	uStr.MaximumLength = ( USHORT ) max (32, RtlAnsiStringToUnicodeSize ( &str ) ) ;
	uStr.Buffer = ( PWSTR ) ExAllocatePoolWithTag ( PagedPool, uStr.MaximumLength, 1633 ) ;
	RtlAnsiStringToUnicodeString ( &uStr, &str, FALSE ) ;
}

CString::~CString() 
{
	ExFreePool ( uStr.Buffer ) ;
	
	uStr.Buffer = NULL ;
	uStr.Length = 0 ;
	uStr.MaximumLength = 0 ;
}

CString& CString::operator += ( const CString& s ) 
{
	*this = *this + s ;
	return *this;
}

CString CString::operator + ( const CString& s ) const 
{
	CString tmp ;
	tmp.uStr.Length = this -> uStr.Length + s.uStr.Length ;
	tmp.uStr.MaximumLength = max (32, tmp.uStr.Length + 2 ) ;
	tmp.uStr.Buffer = ( PWSTR ) ExAllocatePoolWithTag (PagedPool, tmp.uStr.MaximumLength, 1633 ) ;
	RtlCopyUnicodeString ( &tmp.uStr, (PUNICODE_STRING)&this->uStr ) ;
	RtlAppendUnicodeStringToString ( &tmp.uStr, (PUNICODE_STRING)&s.uStr ) ;
	tmp.uStr.Buffer [tmp.uStr.Length / 2 ] = UNICODE_NULL ;
	return tmp ;
}

CString::CString ( const CString& s )
{	
	uStr.Length = 0 ;
	uStr.MaximumLength = s.uStr.MaximumLength ;
	uStr.Buffer = (PWSTR) ExAllocatePoolWithTag ( PagedPool, uStr.MaximumLength, 1633 ) ;
	RtlCopyUnicodeString ( &uStr, (PUNICODE_STRING)&s.uStr ) ;
	uStr.Buffer [ uStr.Length / 2 ] = UNICODE_NULL ;
}

CString CString::operator = ( const CString& s )
{	
	if ( &s != this )
	{
		if ( uStr.Length <= s.uStr.Length )
		{
			if(uStr.Buffer)
				ExFreePool ( uStr.Buffer ) ;
			uStr.Length = 0 ;
			uStr.MaximumLength = s.uStr.MaximumLength ;
			uStr.Buffer = (PWSTR) ExAllocatePoolWithTag ( PagedPool, uStr.MaximumLength, 1633 ) ;
		}
		RtlCopyUnicodeString ( &uStr, (PUNICODE_STRING)&s.uStr ) ;
		uStr.Buffer [ uStr.Length / 2 ] = UNICODE_NULL ;
	}
	return *this ;
}
